
/*  CPU_SPEED for GP2X
    Copyright (C) 2005  Hermes/PS2Reality 
	Modified by Vimacs and god_at_hell(LCD-part)

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <math.h>
#include <time.h>
#include "cpuctrl.h"

/****************************************************************************************************************************************/
//  MAIN
/****************************************************************************************************************************************/

unsigned gp2x_nKeys=0;
int oldtime=0;
unsigned char cad[256];
extern unsigned MDIV,PDIV,SCALE;

int main(int argc, char *argv[])
{
	int h=0; //<-- it's a prescaler for the value added to the initial lcd-timing
	int timer;

	char clockgen = 0;
	unsigned sysfreq=0;
	int cpufreq;

	cpuctrl_init();  // ATENCION: si no se hace esto, cuelgue seguro (aprovecho la definicion de rlyeh y debe ir despues de gp2x_init)

	sysfreq=get_freq_920_CLK();
	sysfreq*=get_920_Div()+1;
	cpufreq=sysfreq/1000000;

	//beginning commandline-utilizing
	if (argc == 3)
	{
		if (atoi(argv[1]) == 0)
		{
			if(atoi(argv[2]) > 36){exit(1);}
			if(atoi(argv[2]) < -20){exit(1);}
			printf ("set Timing-Prescaler = %i\r\n",atoi(argv[2]));
			printf ("...set to FPLL-Clockgen...\r\n");
			set_add_FLCDCLK(atoi(argv[2]));
		}
		else
		{
			if(atoi(argv[2]) > 10){exit(1);}
			if(atoi(argv[2]) < -5){exit(1);}
			printf ("set Timing-Prescaler = %i\r\n",atoi(argv[2]));
			printf ("...set to UPLL-Clockgen...\r\n");
			set_add_ULCDCLK(atoi(argv[2]));
		}
		printf ("set LCD-Timing = 0x%04X\r\n",get_LCDClk());
		printf ("Sys.-Freq. = %uHz M%u P%u S%u\r\n",get_freq_920_CLK(),MDIV-8,PDIV-2,SCALE);
		printf ("UCLK-Freq. = %uHz\r\n",get_freq_UCLK());
		printf ("ACLK-Freq. = %uHz\r\n",get_freq_ACLK());
		return(0);
	}

	if (argc == 4)
	{
		if(atoi(argv[3]) > 320){exit(1);}
		if(atoi(argv[3]) < 33){exit(1);}
		if (atoi(argv[1]) == 0)
		{
			if(atoi(argv[2]) > 36){exit(1);}
			if(atoi(argv[2]) < -20){exit(1);}
			printf ("set Timing-Prescaler = %i\r\n",atoi(argv[2]));
			printf ("...set to FPLL-Clockgen...\r\n");
			set_add_FLCDCLK(atoi(argv[2]));
		}
		else
		{
			if(atoi(argv[2]) > 10){exit(1);}
			if(atoi(argv[2]) < -5){exit(1);}
			printf ("set Timing-Prescaler = %i\r\n",atoi(argv[2]));
			printf ("...set to UPLL-Clockgen...\r\n");
			set_add_ULCDCLK(atoi(argv[2]));
		}
		printf ("set LCD-Timing = 0x%04X\r\n",get_LCDClk());
		printf ("set CPU-Frequency = %uMHz\r\n",atoi(argv[3]));
		set_FCLK(atoi(argv[3]));
		printf ("Sys.-Freq. = %uHz M%u P%u S%u\r\n",get_freq_920_CLK(),MDIV-8,PDIV-2,SCALE);
		printf ("UCLK-Freq. = %uHz\r\n",get_freq_UCLK());
		printf ("ACLK-Freq. = %uHz\r\n",get_freq_ACLK());
		return(0);
	}
	return 1;
}
